
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Better Linux Disk Caching &amp; Performance with vm.dirty_ratio &amp; vm.dirty_background_ratio / 憋错料</title>

    <meta name="description" content="Better Linux Disk Caching &amp; Performance with vm.dirty_ratio &amp; vm.dirty_background_ratio In previous posts on vm.swappiness and using RAM disks we talked about how the memory on a Linux guest is used for the OS itself (the kernel, buffers, etc.), applications, and also for file cache. File caching is an important performance improvement,">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">Better Linux Disk Caching &amp; Performance with vm.dirty_ratio &amp; vm.dirty_background_ratio</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>In previous posts on&nbsp;<a href="https://lonesysadmin.net/2013/12/11/adjust-vm-swappiness-avoid-unneeded-disk-io/" rel="external nofollow noreferrer">vm.swappiness</a>&nbsp;and&nbsp;<a href="https://lonesysadmin.net/2013/12/14/use-ram-disk-improve-disk-access-times/" rel="external nofollow noreferrer">using RAM disks</a>&nbsp;we talked about how the memory on a Linux guest is used for the OS itself (the kernel, buffers, etc.), applications, and also for file cache. File caching is an important performance improvement, and read caching is a clear win in most cases, balanced against applications using the RAM directly. Write caching is trickier. The Linux kernel stages disk writes into cache, and over time asynchronously flushes them to disk. This has a nice effect of speeding disk I/O but it is risky. When data isn’t written to disk there is an increased chance of losing it.</p>
<p>There is also the chance that a lot of I/O will overwhelm the cache, too. Ever written a lot of data to disk all at once, and seen large pauses on the system while it tries to deal with all that data? Those pauses are a result of the cache deciding that there’s too much data to be written asynchronously (as a non-blocking background operation, letting the application process continue), and switches to writing synchronously (blocking and making the process wait until the I/O is committed to disk). Of course, a filesystem also has to preserve write order, so when it starts writing synchronously it first has to destage the cache. Hence the long pause.</p>
<p>The nice thing is that these are controllable options, and based on your workloads &amp; data you can decide how you want to set them up. Let’s take a look:</p>
<pre>$ sysctl -a | grep dirty
 vm.dirty_background_ratio = 10
 vm.dirty_background_bytes = 0
 vm.dirty_ratio = 20
 vm.dirty_bytes = 0
 vm.dirty_writeback_centisecs = 500
 vm.dirty_expire_centisecs = 3000</pre>
<p><strong>vm.dirty_background_ratio</strong>&nbsp;is the percentage of system memory that can be filled with “dirty” pages — memory pages that still need to be written to disk — before the pdflush/flush/kdmflush background processes kick in to write it to disk. My example is 10%, so if my virtual server has 32 GB of memory that’s 3.2 GB of data that can be sitting in RAM before something is done.</p>
<p><strong>vm.dirty_ratio</strong>&nbsp;is the absolute maximum amount of system memory that can be filled with dirty pages before everything must get committed to disk. When the system gets to this point all new I/O blocks until dirty pages have been written to disk. This is often the source of long I/O pauses, but is a safeguard against too much data being cached unsafely in memory.</p>
<p><strong>vm.dirty_background_bytes</strong>&nbsp;and&nbsp;<strong>vm.dirty_bytes</strong>&nbsp;are another way to specify these parameters. If you set the _bytes version the _ratio version will become 0, and vice-versa.</p>
<p><strong>vm.dirty_expire_centisecs</strong>&nbsp;is how long something can be in cache before it needs to be written. In this case it’s 30 seconds. When the pdflush/flush/kdmflush processes kick in they will check to see how old a dirty page is, and if it’s older than this value it’ll be written asynchronously to disk. Since holding a dirty page in memory is unsafe this is also a safeguard against data loss.</p>
<p><strong>vm.dirty_writeback_centisecs</strong>&nbsp;is how often the pdflush/flush/kdmflush processes wake up and check to see if work needs to be done.</p>
<p>You can also see statistics on the page cache in /proc/vmstat:</p>
<pre>$ cat /proc/vmstat | egrep "dirty|writeback"
 nr_dirty 878
 nr_writeback 0
 nr_writeback_temp 0</pre>
<p>In my case I have 878 dirty pages waiting to be written to disk.</p>
<h2>Approach 1: Decreasing the Cache</h2>
<p>As with most things in the computer world, how you adjust these depends on what you’re trying to do. In many cases we have fast disk subsystems with their own big, battery-backed NVRAM caches, so keeping things in the OS page cache is risky. Let’s try to send I/O to the array in a more timely fashion and reduce the chance our local OS will, to borrow a phrase from the service industry, be “<a href="http://www.urbandictionary.com/define.php?term=in%20the%20weeds" rel="external nofollow noreferrer">in the weeds</a>.” To do this we lower vm.dirty_background_ratio and vm.dirty_ratio by adding new numbers to /etc/sysctl.conf and reloading with “sysctl –p”:</p>
<pre>vm.dirty_background_ratio = 5
vm.dirty_ratio = 10</pre>
<p>This is a typical approach on virtual machines, as well as Linux-based hypervisors.&nbsp;I wouldn’t suggest setting these parameters to zero, as some background I/O is nice to decouple application performance from short periods of higher latency on your disk array &amp; SAN (“spikes”).</p>
<h2>Approach 2: Increasing the Cache</h2>
<p>There are scenarios where raising the cache dramatically has positive effects on performance. These situations are where the data contained on a Linux guest isn’t critical and can be lost, and usually where an application is writing to the same files repeatedly or in repeatable bursts. In theory, by allowing more dirty pages to exist in memory you’ll rewrite the same blocks over and over in cache, and just need to do one write every so often to the actual disk. To do this we raise the parameters:</p>
<pre>vm.dirty_background_ratio = 50
vm.dirty_ratio = 80</pre>
<p>Sometimes folks also increase the vm.dirty_expire_centisecs parameter to allow more time in cache. Beyond the increased risk of data loss, you also run the risk of long I/O pauses if that cache gets full and needs to destage, because on large VMs there will be a lot of data in cache.</p>
<h2>Approach 3: Both Ways</h2>
<p>There are also scenarios where a system has to deal with infrequent, bursty traffic to slow disk (batch jobs at the top of the hour, midnight, writing to an SD card on a Raspberry Pi, etc.). In that case an approach might be to allow all that write I/O to be deposited in the cache so that the background flush operations can deal with it asynchronously over time:</p>
<pre>vm.dirty_background_ratio = 5
vm.dirty_ratio = 80</pre>
<p>Here the background processes will start writing right away when it hits that 5% ceiling but the system won’t force synchronous I/O until it gets to 80% full. From there you just size your system RAM and vm.dirty_ratio to be able to consume all the written data. Again, there are tradeoffs with data consistency on disk, which translates into risk to data. Buy a UPS and make sure you can destage cache before the UPS runs out of power. :)</p>
<p>No matter the route you choose you should always be gathering hard data to support your changes and help you determine if you are improving things or making them worse. In this case you can get data from many different places, including the application itself, /proc/vmstat, /proc/meminfo, iostat, vmstat, and many of the things in /proc/sys/vm. Good luck!</p>
<p>注：</p>
<p>1、vm.dirty_background_ratio是指脏页的数量占用缓存的比率达到该数值时，后台调用pdflush/flush/kdmflush写入进程时会将脏页落盘。此时执行的写入操作是异步写入，不会阻塞应用程序的写入。</p>
<p>2、vm.dirty_ratio是指脏页的数量占用缓存的比率达到该数值时，新产生的io操作将会被阻塞，直到产生的脏页写入到磁盘。此时的写入是同步操作，会阻塞应用程序的写入。虽然前面已经有了vm.dirty_background_ratio，可能有的人认为后面的vm.dirty_ratio是不必要的，其实不然，当程序的写入速度远超操作系统的落盘速度时，脏页比率是有可能达到vm.dirty_ratio的。此时，为了减少宕机时，数据的丢失，则进行同步写入操作。</p>
<p>3、至于vm.dirty_background_bytes和vm.dirty_bytes的含义和上面等同，只是比率改为数值而已</p>
<p>4、上面两个比率参数，是相对的是缓存，而不是操作系统的物理内存，上面举了一个32GB内存的例子，计算的结果是有误的。</p>
<p>缓存的计算是：</p>
<pre>VmSize = memory + memory-mapped</pre>
<pre>Actually, a couple things. The article has the intent correct, but some of the details aren‘t.
The total size of the page cache, the last I looked, was MemFree + Cached - Mapped, which is not equal to the size the physical memory in the system. You can find these amounts in /proc/meminfo, which also list a number of interesting things about the dirty cache behavior in a system.
[email&#160;protected]:/proc# grep -i free meminfo
MemFree:         3638108 kB
SwapFree:        3999996 kB
HugePages_Free:        0
[email&#160;protected]:/proc# grep -i dirty meminfo
Dirty:                12 kB
[email&#160;protected]:/proc# grep -i write meminfo
Writeback:             0 kB
WritebackTmp:          0 kB
[email&#160;protected]:/proc#
I have read several times that the dirty cache behavior is used by ext2+ to make index and data writes more efficient. As I understand it, the longer the data is held in cache before being written to the media, the fewer inode/index updates it will actually do. So, for flash type media, holding writes does make sense if you are interested in increasing the longevity of the flash memory.
Also, in Linux, the cache can always be assumed to be the size of MemFree + Cached - Mapped, it will never be any bigger or smaller than that. The only tuning option is how much of that memory do you want holding data waiting for writeback (dirty).
These are fairly minor, the intent of the article seems sound.
For the sake of discussion, here‘s the dirty_* parameters off of that server.
[email&#160;protected]:/proc/sys/vm# grep . dirty_*
dirty_background_bytes:0
dirty_background_ratio:1
dirty_bytes:0
dirty_expire_centisecs:360000
dirty_ratio:40
dirty_writeback_centisecs:500
[email&#160;protected]:/proc/sys/vm#
Years ago, I did quite a bit of custom tuning for each of my systems. I‘ve somewhat settled on the above. These work well in nearly every situation, from Raspi‘s/Odroids, systems running off USB, to the largest general purpose DC boxes.
There are a few situations that this wouldn‘t work well for, database servers in particular, but these settings are safer than the default, and perform better.
Take it for what you will.</pre>
<p>5、另外，vm.dirty_writeback_centisecs和vm.dirty_expire_centisecs的单位是百分之一秒。</p>
<p>6、这是操作系统缓存部分的落盘，至于数据库的buffer则由自己管理了，不过因为存在数据库缓存和操作系统缓存双缓存的存在，在数据库参数设置合理的情况下，也要注意操作系统缓存的调整，虽然数据库是先写日志，缓存中的数据能否及时落盘，也就没有那么重要了。但操作系统参数的设置还是会影响到磁盘io的使用。</p>
<p>参考：</p>
<p>https://lonesysadmin.net/2013/12/22/better-linux-disk-caching-performance-vm-dirty_ratio/</p>
<p>https://www.reddit.com/r/linux/comments/3h7w8f/better_linux_disk_caching_performance_with/</p>
<p>http://www.cnblogs.com/xiaotengyi/p/6907190.html</p>
<p>https://www.kernel.org/doc/Documentation/sysctl/vm.txt</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-01-31 01:57:35 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/add/" title="add">add</a>, <a href="https://www.biecuoliao.com/tag/%e7%a8%8b%e5%ba%8f/" title="程序">程序</a>, <a href="https://www.biecuoliao.com/tag/%e5%ba%94%e7%94%a8/" title="应用">应用</a>, <a href="https://www.biecuoliao.com/tag/containe/" title="containe">containe</a>, <a href="https://www.biecuoliao.com/tag/%e7%bc%93%e5%ad%98/" title="缓存">缓存</a>, <a href="https://www.biecuoliao.com/tag/imu/" title="imu">imu</a>, <a href="https://www.biecuoliao.com/tag/sync/" title="sync">sync</a>, <a href="https://www.biecuoliao.com/tag/decide/" title="decide">decide</a>, <a href="https://www.biecuoliao.com/tag/trying/" title="trying">trying</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>Better Linux Disk Caching &amp; Performance with vm.dirty_ratio &amp; vm.dirty_background_ratio的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/35qNPV3.html" rel="bookmark">vm&period;dirty&lowbar;ratio &amp;amp&semi; vm&period;dirty&lowbar;background&lowbar;ratio</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				https://lonesysadmin.net/2013/12/22/better-linux-disk-caching-performance-vm-dirty_ratio/ Better Linux Disk Caching &amp; Performance with vm.dirty_ratio &amp; vm.dirty_background_ratio Bob Plankers December 22, 2013 Best Practices, Cloud, System Administ			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MoX5Pk0.html" rel="bookmark">Disk IO Performance</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1,Physical Disk vs. Logical Disk Windows可以在一个Physical Disk上划出若干个逻辑分区,每一个逻辑分区是一个Logical Disk.对于分配在同一个Physical Disk上的Logical Disks,其读写操作共享Physical Disk的IO带宽.Windows给每一个Logical Disk分配一个盘符,App通过盘符来读写数据. 关于Disk Performance,有两组counter:Logical Disk 和 Physic			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0K7rxO0.html" rel="bookmark">Linux系统入门学习：改变libvirt VM镜像的默认位置</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				提问: 我使用libvirt和virt-manager在我的Linux系统上创建虚拟机.我注意到虚拟机镜像位于/var/lib/libvirt/images目录.有没有办法改变虚拟机镜像的默认路径? libvirt和它的GUI前端 virt-manager 可以使用不同的虚拟机管理程序创建和管理VM,例如LVM和Xen.默认上所有的虚拟机镜像通过 libvirt 创建到/var/lib/libvirt/images目录.然而,这有时并不是我们希望的.比如 /var/lib/libvirt/ima			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0aoQLP4.html" rel="bookmark">&lbrack;Linux&rsqb; Disk management</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Linux磁盘管理 I/O Ports: I/O设备地址: 一切皆文件: open(), read(), write(), close() 块设备:block,存取单位&quot;块&quot;,磁盘 字符设备:char,存取单位&quot;字符&quot;,键盘 设备文件:关联至一个设备驱动程序,进而能够跟与之对应硬件设备进行通信: 设备号码: 主设备号:major number, 标识设备类型 次设备号:minor number, 标识同一类型下的不同设备 硬盘接口类型: 并行: IDE:133MB/			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/41wDlo0.html" rel="bookmark">DBA不可不知的操作系统内核参数</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				背景 操作系统为了适应更多的硬件环境,许多初始的设置值,宽容度都很高. 如果不经调整,这些值可能无法适应HPC,或者硬件稍好些的环境. 无法发挥更好的硬件性能,甚至可能影响某些应用软件的使用,特别是数据库. 数据库关心的OS内核参数 512GB 内存为例 参数 fs.aio-max-nr 支持系统 CentOS 6, 7 参数解释 aio-nr &amp; aio-max-nr: . aio-nr is the running total of the number of events specifie			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MWyPx63.html" rel="bookmark">Azure上批量创建OS Disk大于30G的Linux VM</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Azure上VM的OS盘的大小在创建时是固定的.Windows是127G,Linux是30G.如果需要批量创建的VM的OS Disk有更大的容量.可以考虑用下面的方法实现. 1 创建一台有Data-disk的CentOS VM,对其进行客户化,安装软件,挂载磁盘 2 扩大OS Disk的容量 3 在VM内resize OS Disk的容量 4 把这台VM捕获成Azure的Image 5 通过这个Image批量创建VM.创建VM的OS Disk容量是刚刚调整的容量 本文将采用Azure CLI 2			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4Nar5w3.html" rel="bookmark">Linux Performance Tunnel</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				process:一个独立运行的单位 资源:CPU资源,内存资源 CPU: 时间:切片 缓存:缓存当前程序的数据 内存: 空间:映射 线性地址 &lt;---- 物理地址 线性地址:进程运行时认为自己可使用的空间 物理地址:实际内存的空间 进程描述符: 进程元数据 通过一个双向链表(C语言中的struct)描述 Linux:抢占 系统时钟:时钟 tick:滴答 时间解析度 进程类别: 交互式进程:I/O密集型 批处理进程:CPU密集型 实时(Real-time)进程 CPU密集型:时间片长,优先级低 I			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/g417Gq0.html" rel="bookmark">linux &sol;proc&sol;sys&sol;vm&sol;中各个文件含义</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1)      /proc/sys/vm/block_dump该文件表示是否打开Block Debug模式,用于记录所有的读写及Dirty Block写回动作. 缺省设置:0,禁用Block Debug模式2)      /proc/sys/vm/dirty_background_ratio该文件表示脏数据到达系统整体内存的百分比,此时触发pdflush进程把脏数据写回磁盘. 缺省设置:103)      /proc/sys/vm/dirty_expire_centisecs该文件表示如果脏数据			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0lDoYB0.html" rel="bookmark">Eager thick vs Lazy thick disk performance</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				The VMware Thick Eager Zeroed Disk vs the Lazy Zeroed Thick disk in write performance. What is the potential write performance difference between the VMware virtual disks: Thick Lazy Zeroed, Thick Eager Zeroed and Thin provisioned types? This has bee			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXYLGb0.html" rel="bookmark" class="title">Android开发手记&lpar;29&rpar; 基于Http的LaTeX数学公式转换器</a>
					<div>
						本文将讲解如何通过codecogs.com和Google.com提供的API接口来将LaTeX数学函数表达式转化为图片形式.具体思路如下: (1)通过EditText获取用户输入的LaTeX数学表达式 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDdvB9M.html" rel="bookmark" class="title">MVC4中的Display Mode简介</a>
					<div>
						本文地址:http://www.cnblogs.com/egger/p/3400076.html  欢迎转载 ,请保留此链接?•? ?•??! 今天学习MVC4时,看到一个不错的特性&quot;vie ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YYRZa0.html" rel="bookmark" class="title">python笔记四：面向对象</a>
					<div>
						1.类 class Student(object): def __init__(self, name, score): self.name = name self.score = score 1)__ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Momxxw3.html" rel="bookmark" class="title">栈，堆，静态存储区</a>
					<div>
						1.栈是先入后出, 2.栈保存了一个函数调用所需的维护信息,函数参数,函数返回地址,局部变量,函数调用上下文.没有栈就没有函数,没有局部变量. 3. 栈保存了一个函数调用所需的维护信息(函数参数,函数 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02LNNA4.html" rel="bookmark" class="title">地理杂志精选照片</a>
					<div>
						查看全文					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NaPoJ3.html" rel="bookmark" class="title">hihocoder 1236&lpar;2015北京网络赛 J题&rpar; 分块bitset乱搞题</a>
					<div>
						题目大意: 每个人有五门课成绩,初始给定一部分学生的成绩,然后每次询问给出一个学生的成绩,希望知道在给定的一堆学生的成绩比这个学生每门都低或者相等的人数 因为强行要求在线查询,所以题目要求,每次当前给 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/35qGmv3.html" rel="bookmark" class="title">mysql开机自启动设置</a>
					<div>
						原创作品,出自 &quot;深蓝的blog&quot; 博客,欢迎转载,转载时请务必注明出处,否则追究版权法律责任. 深蓝的blog:http://blog.csdn.net/huangyanlong ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4A6nWaM.html" rel="bookmark" class="title">《机器学习那些事》摘要</a>
					<div>
						&lt;机器学习那些事&gt;介绍了一些机器学习应用中需要了解的&quot;民间知识&quot;. 原文为: A Few Useful Things to Know about Machine Lea ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vQPKR0.html" rel="bookmark" class="title">【ML入门系列】（三）监督学习和无监督学习</a>
					<div>
						概述 在机器学习领域,主要有三类不同的学习方法: 监督学习(Supervised learning) 非监督学习(Unsupervised learning) 半监督学习(Semi-supervise ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YRVpX3.html" rel="bookmark" class="title">观《一万年以后》的感想</a>
					<div>
						&lt;一万年以后&gt;是一个动画片,讲的是一万年以后,乌族的部落首领&quot;乌神&quot;从众神遗迹窃取了上古魔法,为了满足自己的野心,居然想让地球重回邪恶的上古时代的故事. 那我们不得不去 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YDo9JM.html" rel="bookmark" class="title">初级JavaWeb攻城狮面试指导&lpar;二&rpar;</a>
					<div>
						一.Java面向对象必会知识点 Java的核心是面向对象编程,所有的java程序都是面向对象的.需要看清Java的本质,从复杂的表象中寻找普遍的规律,并深刻理解Java的核心思想. 1.面向对象的特点 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzLP183.html" rel="bookmark" class="title">详解网络流量监控&amp;&num;8203&semi;</a>
					<div>
						详解网络流量监控 网络的行为特征可以通过其承载的流量的动态特性来反映,所以有针对性地监测网络中流量的各种参数(如接收和发送数据报大小.丢包率.数据报延迟等信息),能从这些参数中分析网络的运行状态.通过 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nRkej0.html" rel="bookmark" class="title">Android源代码同步脚本（增加设置线程参数）</a>
					<div>
						#!/bin/sh #Filename: repo_sync.sh count=0 ret=1 while [ $ret -ne 0 ] do #输入参数1,用作同步的线程数 #如果什么参数都不输入, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47eQ7D0.html" rel="bookmark" class="title">html5 canvas防微博旋转</a>
					<div>
						&lt;!doctype html&gt; &lt;html&gt; &lt;head&gt; &lt;meta charset=&quot;utf-8&quot;&gt; &lt;title&gt; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLRbXA3.html" rel="bookmark" class="title">linux用grep查找文件内容</a>
					<div>
						从文件内容查找匹配指定字符串的行: $ grep &quot;被查找的字符串&quot; 文件名 从文件内容查找与正则表达式匹配的行: $ grep –e “正则表达式” 文件名 查找时不区分大小写: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPe2gD0.html" rel="bookmark" class="title">HAWQ与Hive查询性能对比测试</a>
					<div>
						一.实验目的 本实验通过模拟一个典型的应用场景和实际数据量,测试并对比HAWQ内部表.外部表与Hive的查询性能. 二.硬件环境 1. 四台VMware虚机组成的Hadoop集群.2. 每台机器配置如 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDj18k3.html" rel="bookmark" class="title">HTML5新特性之WebSocket</a>
					<div>
						一.WebSocket简介: 谈到Web实时推送,就不得不说WebSocket.在WebSocket出现之前,很多网站为了实现实时推送技术,通常采用的方案 是轮询(Polling)和Comet技术,C ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3Za8OJ0.html" rel="bookmark" class="title">教育部长：将引z</a>
					<div>
						2.一站到底:&quot;赏.玩.游.食.住.行&quot;民生全覆盖的一站式综合展销平台: 我去宁德当地委书记之前,省领导找我谈话说,福建9个地市,宁德经济排老九,宁德的同志到省里开会,都坐在最后一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBnznyM.html" rel="bookmark" class="title">Oracle 外网访问</a>
					<div>
						环境:centos7+oracle 11gr2 公网:固定IP 症状:1521端口正常,netmanager配置测试正常,plsql连接提示ORA-12514: TNS:listener does n ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVWprk0.html" rel="bookmark" class="title">Struts2 内建的验证规则</a>
					<div>
						conversion validator:转换验证器 date validator:日期验证器 double validator:浮点验证器 email validator:email 验证器 exp ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.025 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
